//+------------------------------------------------------------------+
//|                                              Sixty MA Entry      |
//|                                                                  |
//| SlovForex posted strategy on Forex Factory on April 10, 2012.    |
//| Looks easy to code an entry indicator.  Let's see...             |
//| 1) on piercing of 60 WMA.                                        |
//| 2) Set entry oportunity at last Swing of same direction + 2 pips |
//|    No given rules for Swing... Use iFractal.                     |
//| This indicator Draws a line at the Entry Indication.             |
//+------------------------------------------------------------------+
//
#property copyright "LukeB"
#property link      "http://www.forexfactory.com/lukeb"
string indicatorName = "Sixty MA Entry";
string Version =    "V1.00";
//
#include <WinUser32.mqh>
#include <stdlib.mqh>
#include <stderror.mqh>
//
#define CHARTSYMBOL  0
#define CHARTTF      0
#define NOVALUE      0
#define NOCHARTSHIFT 0
#define ACTIVEBAR    0
#define ZEROWINDOW   0
#define BARZERO      0
#define BARONE       1
#define INDICATORMA  60  // The MA for the detector.
#define TRENDBARS    5   // How Many Bars for Trend Detection
#define BREAKOUTPIPS 2
//
#define NOLINETYPE       0
#define BUYLINETYPE      1
#define SELLLINETYPE     2
//
#property indicator_chart_window
#property indicator_buffers 0
// #property indicator_color1 OrangeRed  
// #property indicator_color2 Lime      
// #property indicator_color3 Green      
// #property indicator_color4 Blue       
// #property indicator_color5 Turquoise  
// #property indicator_color6 Salmon     
// #property indicator_color7 CLR_NONE   
//
string EntryLine;                    // EA gets this object and determine if it should trade.
string SwingFoundTime;
bool NewBar;
double BreakOutPips;
//
int MaxBarsToProcess = 3000;
string newLine = "\n";
int MinBarCount;    // have to have this many bars to work properly.
//
//Arrays to control on-screen Object properties
string ObjName[]= {"Buy Line","Sell Line"};
// int    ObjCrnr[]= {NA,         NA};
color  ObjClr[] = {Salmon,     Turquoise};
int    ObjWidth[]= {2,         2};
#define BUYLINE    0
#define SELLLINE   1
//
int init()
{
   string shortName=indicatorName+Version;
   IndicatorShortName(shortName);
   MinBarCount = INDICATORMA;        // have to have this many bars to work properly.
   BreakOutPips = ConvertPipsToPoints(BREAKOUTPIPS);
   return (0);
}
int deinit()
{
   RemoveObjects();
   return (0);
}
int start()
{
   static int ticCount = 0;
   ticCount ++;
   int oldestUnprocessedBar;
   NewBar = DetectNewBar();
   if (NewBar)
   {
      oldestUnprocessedBar = GetOldestBarToProcess(ticCount);   //  Get the oldest bar to process.
      ProcessUnproccesedBars(oldestUnprocessedBar);
      
   }
   return (0);
}
bool DetectNewBar()
{
   static datetime lastZeroBarTime = 0;
   bool newBar;
   if ( Time[0] != lastZeroBarTime ) // A new Bar Zero has been made.
   {  newBar = true;
      lastZeroBarTime = Time[0];
   } else
   {
      newBar = False;
   }
   return(newBar);
}
int GetOldestBarToProcess(int tickCount) 
{
   int countedBars=IndicatorCounted();
   int maxTimeFrameBarCount = iBars(CHARTSYMBOL,CHARTTF);
   int firstBarToProcess = Bars-countedBars-1;
   if ( firstBarToProcess > 2)  // only do all the calculations for startup
     {
      if (firstBarToProcess > MaxBarsToProcess)
     {
        firstBarToProcess = MaxBarsToProcess;
     }
     if ( maxTimeFrameBarCount < MinBarCount )  //  not enough history
     {
        string commentString;
        if ( (MathMod(tickCount, 100) == 1) )  // No need to blast the system with Prints, or elimiate all other comments all the time.
        {
           commentString = StringConcatenate("There are only ",maxTimeFrameBarCount,
                           " Bars, and the MA Calculation Requires ",INDICATORMA," for the iMA function.  ",tickCount);
           Comment(commentString);
        }
        firstBarToProcess = maxTimeFrameBarCount-1;  //  Do as well as can be done.
     }
   }
   return(firstBarToProcess);
}
void ProcessUnproccesedBars(int oldestUnprocessedBar)
{
   int barToProcess;
   bool endLine;
   int compareStringLen;
   double indicatorMA;
   
   for (barToProcess = oldestUnprocessedBar; barToProcess>0; barToProcess--)
   {
      indicatorMA = iMA(CHARTSYMBOL,CHARTTF,INDICATORMA,NOCHARTSHIFT,MODE_EMA,PRICE_CLOSE,barToProcess);
      compareStringLen = StringLen(ObjName[BUYLINE]);
      if (StringLen(EntryLine) > 0)  // There is an active trading line
      {
         if (StringSubstr(EntryLine,0,compareStringLen) == ObjName[BUYLINE])  // A Buy Line is Active
         {
            endLine = DetectBuyEntryLineEnd(indicatorMA, barToProcess);
         } else // A Sell Line is Active
         {
            endLine = DetectSellEntryLineEnd(indicatorMA, barToProcess);
         }
         if (endLine)
         {
            EntryLine = "";
            NewLineCreation(indicatorMA,barToProcess);
         } else  // make it one bar longer
         {
            UpdateEntryLine(EntryLine,barToProcess);
         }
      } else  // See if a line should be created
      {
         NewLineCreation(indicatorMA,barToProcess);
      }
   }
}
void NewLineCreation(double indicatorMA,int barToProcess)
{
   int entryLineType = DetectEntryLineStart(indicatorMA,barToProcess);
   if (entryLineType != NOLINETYPE)
   {
      double strikePrice = GetEntryLinePrice(barToProcess,entryLineType);
      if (strikePrice >0) // Got a strike price
      {
         string lineName = MakeLineName(indicatorMA,entryLineType);
         EntryLine = PlaceNewEntryLine(lineName,strikePrice, barToProcess,indicatorMA,entryLineType);
      }
   }
}
bool DetectBuyEntryLineEnd(double indicatorMA, int barToProcess)
{
   bool endLine = false;
   if (Low[barToProcess] < indicatorMA) //  PA has moved to the wrong side of the iMA
   {
      endLine = true;
   }
   double strikePrice = GetStrikePrice(EntryLine);
   if ( (strikePrice > NOVALUE) && (High[barToProcess] > strikePrice) )  //  PA is now above the Strike Price;  Use Bid for detection, Buy Line will include Spread consideration.
   {
      endLine = true;
   }
   return(endLine);
}
bool DetectSellEntryLineEnd(double indicatorMA, int barToProcess)
{
   bool endLine = false;
   if (High[barToProcess] > indicatorMA) //  PA has moved to the wrong side of the iMA
   {
      endLine = true;
   }
   double strikePrice = GetStrikePrice(EntryLine);
   if ( (strikePrice > NOVALUE) && (Low[barToProcess] < strikePrice) )  //  PA is now below the Strike Price;
   {
      endLine = true;
   }
   return(endLine);
}
double GetStrikePrice(string strikeLine)
{
   double strikePrice=0;
   strikePrice = ObjectGet(strikeLine, OBJPROP_PRICE1);  // Get the price value of the line
   if (!strikePrice)
   {
      string errDesc = StringConcatenate(strikeLine," price not found, Error: ",GetLastError(),
                       ", ",ErrorDescription(GetLastError()));
      Alert(errDesc);
      Print(errDesc);
   }
   return(strikePrice);
}
void UpdateEntryLine(string lineToUpdate, int barToProcess)
{
   static int callCount = 0;
   callCount++;
   if (!ObjectSet(lineToUpdate, OBJPROP_TIME2,  Time[barToProcess]+(Period()*60)) )  // Update the end coordinate, make the line longer
   {                                                                                   // *60 converts minutes to seconds.
      string errDesc = StringConcatenate(lineToUpdate," update failed, Error: ",GetLastError(),
                       ", ",ErrorDescription(GetLastError()));
      Alert(errDesc);
      Print(errDesc);
   }
}
int DetectEntryLineStart(double indicatorMA,int barToProcess)
{
   int makeLineType = NOLINETYPE;
   if ( (Low[barToProcess] <= indicatorMA) && (indicatorMA < Close[barToProcess]) ) // don't triger on a dojo on piercing Up
   {
      makeLineType = BUYLINETYPE;
   } else if( (High[barToProcess] >= indicatorMA) && (indicatorMA > Close[barToProcess]) )  // don't triger on a dojo on piercing down
   {
      makeLineType = SELLLINETYPE;
   }
   return(makeLineType); 
}
double GetEntryLinePrice(int barToProcess,int entryLineType)
{
   double swingValue;
   int    swingType;
   
   swingType = GetSwingType(entryLineType);
   swingValue = GetSwingBarInfo(entryLineType, swingType, barToProcess);
   
   return(swingValue);
}
int GetSwingType(int entryLineType)
{
   int swingType;
   switch (entryLineType)
   {
      case BUYLINETYPE:
      {
         swingType = MODE_UPPER;
         break;
      }
      default:  // SELLLINETYPE
      {
         swingType = MODE_LOWER;
      }
   }
   return(swingType);
}
double GetSwingValue(int lookBackBar,int swingMode)
{
   double swingValue = iFractals(CHARTSYMBOL,CHARTTF, swingMode, lookBackBar);
   return(swingValue);
}
double GetSwingBarInfo(int entryLineType, int swingType, int barToProcess)
{
   bool swingFound = false;
   double strikePrice;
   double swingValue;
   int lookBackBar;
   for(lookBackBar=barToProcess+1; (lookBackBar < Bars-1) && ((lookBackBar-barToProcess) < 200); lookBackBar++)   //  Go back in time looking for a fractal
   {
      swingValue = GetSwingValue(lookBackBar,swingType);
      switch (entryLineType)
      {
         case BUYLINETYPE:
         {
            if (swingValue > High[barToProcess])  // as these are bid bars, I wonder if I should add the spread.  I think as Fracal is from Bid, it is compensated.
            {
               swingFound = true;
               SwingFoundTime = StringConcatenate("High Swing ",entryLineType,
                                  ",: ",DoubleToStr(swingValue,Digits),", Time: ",TimeToStr(Time[lookBackBar],TIME_DATE|TIME_MINUTES));
            }
            break;
         }
         default:    // case SELLLINETYPE:
         {
            if ((swingValue > 0) && (swingValue < Low[barToProcess]) )  // Got a value and it's less than the PA.
            {
               swingFound = true;
               SwingFoundTime = StringConcatenate("Low swing ",entryLineType,
                                   ": ",DoubleToStr(swingValue,Digits),", Time: ",TimeToStr(Time[lookBackBar],TIME_DATE|TIME_MINUTES));
            }
         }
      }
      if (swingFound)
      {
         break;  // stop looking back in time
      }
   }
   if (!swingFound)  // No relevant swing exists for the piercing, use the value of the piercing bar.
   {
      switch (entryLineType)
      {
         case BUYLINETYPE:
         {
            strikePrice = High[barToProcess] + (Ask-Bid) + BreakOutPips;
            SwingFoundTime = StringConcatenate("High swing not found ",entryLineType,
                                 ": Bar Time: ",TimeToStr(Time[barToProcess],TIME_DATE|TIME_MINUTES));
            break;
         }
         default:  // SELLLINETYPE
         {
            strikePrice = Low[barToProcess] - BreakOutPips;
            SwingFoundTime = StringConcatenate("Low swing not found ",entryLineType,
                                 ": Bar Time: ",TimeToStr(Time[barToProcess],TIME_DATE|TIME_MINUTES));
         }
      }
   } else  // swing was found
   {
      switch (entryLineType)
      {
         case BUYLINETYPE:
         {
            strikePrice = swingValue + (Ask-Bid) + BreakOutPips;
            break;
         }
         default:  // SELLLINETYPE
         {
            strikePrice = swingValue - BreakOutPips;
         }
      }
   }
   return(strikePrice);
}
string MakeLineName(double MAValue,int entryLineType)
{
   static int lineCounter = 0;
   lineCounter++;
   string lineName;
   switch (entryLineType)
   {
      case BUYLINETYPE:
      {
         lineName = StringConcatenate(ObjName[BUYLINE]," ",lineCounter);
         break;
      }
      default:  // SELLLINETYPE
      {
         lineName = StringConcatenate(ObjName[SELLLINE]," ",lineCounter);
      }
   }
   return(lineName);
}
string PlaceNewEntryLine(string lineName, double strikePrice, int barToProcess, double MAValue,int entryLineType)
{
   int buyOrSell;
   string objectText;
   string barInfo;
   switch (entryLineType)
   {
      case BUYLINETYPE:
      {
         buyOrSell = BUYLINE;
         barInfo =StringConcatenate("High: ",DoubleToStr(High[barToProcess],Digits)); 
         break;
      }
      default: // SELLLINETYPE
      {
         buyOrSell = SELLLINE;
         barInfo =StringConcatenate("Low: ",DoubleToStr(Low[barToProcess],Digits)); 
      }
   }
   ObjectCreate(lineName,OBJ_TREND,ZEROWINDOW,Time[barToProcess],strikePrice,Time[barToProcess]+(Period()*60),strikePrice,0,0);
   ObjectSet(lineName,   OBJPROP_RAY, false);
   ObjectSet(lineName,   OBJPROP_WIDTH, ObjWidth[buyOrSell]);
   ObjectSet(lineName,   OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet(lineName,   OBJPROP_COLOR,ObjClr[buyOrSell]);
   objectText = (/*StringConcatenate(" iMA: ",DoubleToStr(MAValue,Digits),", ",barInfo,", Starting ",
                                    TimeToStr(Time[barToProcess],TIME_DATE|TIME_MINUTES),", ",*/
                                    SwingFoundTime);
   ObjectSetText(lineName, objectText, 10, "Ariel", ObjClr[buyOrSell]);
   return(lineName);
}
void RemoveObjects()
{
   for (int objIdx = ObjectsTotal(EMPTY)-1; objIdx >= 0 ; objIdx--)  // end to start so the index #'s don't change during the loop through
   {
      string objString = ObjectName(objIdx);  // Capture the name of the object referenced by the index
      // If the Found Object's name matches any of this indicator objects names, delete it.
      for ( int indIdx = 0; indIdx < ArraySize(ObjName); indIdx++)
      {
         string indIdxName  = ObjName[indIdx];  // get a name from the indicators list of object names
         string matchString = StringSubstr(objString,0,StringLen(indIdxName));  //  Get an applicable lenght of string from the object's name
         if ( matchString == indIdxName )  // See if name matches name in control array
         {
            ObjectDelete(objString);  // Delete Name Matched Object
            break;  // Object is gone, no need to try and delete it again, go get the next object.
         }
      }
   }
}
double ConvertPipsToPoints(double valueToConvert)
{  // pips to points, as in 1.55 to 0.00015 in a 5 digit system. (1.5*10)*10^(-5)
   // remove extra precision, 1.55 becomes 15, not 15.5)
   // is "Points" always equal to MathPow(10,-Digits)?  I think it must be, and would be a little more effecient.
   valueToConvert = MathFloor(valueToConvert*TicksInAPip())*MathPow(10,-Digits); // pips to points.
   return(valueToConvert);
}
int TicksInAPip()  //  Not a direct way to do this, but I believe this returns correct value always (until we get 6 digit brokers).
{
   if ( (Digits==5) || (Digits==3) )
   {
      return(10);
   } else
   {
     return(1);
   }
}